%global gnupg24_ver 2.4.5
%global libgpg_error_ver 1.48
%global npth_ver 1.7
%global libgcrypt_ver 1.10.3
%global libassuan_ver 2.5.7
%global libksba_ver 1.6.6
%global sqlite_ver 3280000
%global ntbtls_ver 0.3.2

Name:           gnupg24-static
Version:        %{gnupg24_ver}
Release:        1%{?dist}
Summary:        Static-built newer version of gnupg-2.4.x
Obsoletes:      gnupg23-static < 2.4

License:        GPLv3+
URL:            https://gnupg.org
Source0:        https://gnupg.org/ftp/gcrypt/gnupg/gnupg-%{gnupg24_ver}.tar.bz2
Source10:       https://gnupg.org/ftp/gcrypt/libgpg-error/libgpg-error-%{libgpg_error_ver}.tar.bz2
Source11:       https://gnupg.org/ftp/gcrypt/npth/npth-%{npth_ver}.tar.bz2
Source12:       https://gnupg.org/ftp/gcrypt/libgcrypt/libgcrypt-%{libgcrypt_ver}.tar.bz2
Source13:       https://gnupg.org/ftp/gcrypt/libassuan/libassuan-%{libassuan_ver}.tar.bz2
Source14:       https://gnupg.org/ftp/gcrypt/libksba/libksba-%{libksba_ver}.tar.bz2
Source15:       https://gnupg.org/ftp/gcrypt/sqlite/sqlite-autoconf-%{sqlite_ver}.tar.gz
Source16:       https://gnupg.org/ftp/gcrypt/ntbtls/ntbtls-%{ntbtls_ver}.tar.bz2
Source100:      https://versions.gnupg.org/swdb.lst

BuildRequires:  gcc-c++ curl-devel gnutls-devel sqlite-devel openldap-devel zlib-devel bzip2-devel

%description
Provides a statically-built gnupg-2.4 in /opt/gnupg24.

This is not a substitute for a complete gnupg installation, but will do in
a situation when you need to work with ECC subkeys (the version of gnupg2 in
CentOS-7 does not handle ECC crypto).

If you need to use auxiliary programs like gpg-agent or dirmngr, you may
need to tell gpg where to find them, because the default static build scripts
hardcode the buildroot locations. E.g., in your gpg.conf:

agent-program   /opt/gnupg24/bin/gpg-agent
dirmngr-program /opt/gnupg24/bin/dirmngr


%prep
%autosetup -N -n gnupg-%{version}
cp %{SOURCE100} swdb.lst
%{__mkdir_p} PLAY/src

%build
pushd PLAY/src
tar xf %{SOURCE10}
tar xf %{SOURCE11}
tar xf %{SOURCE12}
tar xf %{SOURCE13}
tar xf %{SOURCE14}
tar xf %{SOURCE15}
tar xf %{SOURCE16}
ln -s libgpg-error-* libgpg-error
ln -s npth-* npth
ln -s libgcrypt-* libgcrypt
ln -s libassuan-* libassuan
ln -s libksba-* libksba
ln -s sqlite-autoconf-* sqlite
ln -s ntbtls-* ntbtls
popd
cat <<EOF > config.mk
speedo_spkgs = libgpg-error npth libgcrypt sqlite libassuan libksba ntbtls gnupg
speedo_pkg_gnupg_configure += --prefix=/opt/gnupg24
speedo_pkg_gnupg_make_args_inst="DESTDIR=$PWD/PLAY/buildroot"
EOF
%{__make} -f build-aux/speedo.mk STATIC=1 CUSTOM_SWDB=1 INSTALL_PREFIX=. this-native


%install
%{__mkdir_p} %{buildroot}/opt
%{__cp} -a PLAY/buildroot/opt/gnupg24 %{buildroot}/opt/gnupg24

%files
%license COPYING
/opt/gnupg24


%changelog
* Wed Mar 13 2024 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.4.5-1
- Update to 2.4.5

* Wed Jan 31 2024 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.4.4-1
- Update to 2.4.4
- Build with bundled sqlite3 and ntbtls
- Don't attempt to build bundled zlib and bzip2

* Tue Jan 17 2023 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.4.0-1
- Release 2.4.0 as gnupg24-static
- This package obsoletes gnupg23-static

* Tue Oct 18 2022 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.3.8-1
- Update to gnupg-2.3.8

* Wed Jul 13 2022 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.3.7-1
- Update to gnupg-2.3.7

* Tue Apr 26 2022 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.3.6-1
- Update to gnupg-2.3.6

* Fri Apr 22 2022 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.3.5-1
- Update to gnupg-2.3.5

* Mon Jan 17 2022 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.3.4-1
- Update to gnupg-2.3.4

* Wed Apr 21 2021 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.3.1-1
- Split off gnupg23-static for gnupg-2.3.x

* Mon Jan 25 2021 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.2.27-1
- Update to gnupg-2.2.27

* Wed Nov 25 2020 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.2.25-1
- Update to gnupg-2.2.25

* Thu Nov 19 2020 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.2.24-1
- Update to gnupg-2.2.24

* Fri Sep 04 2020 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.2.23-1
- Update to gnupg-2.2.23

* Mon Mar 23 2020 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.2.20-1
- Update to gnupg-2.2.20

* Thu Dec 19 2019 Benjamin Gordon <ben@bxg.org> - 2.2.19-1
- Update to gnupg-2.2.19
- Change the built-in default paths to point into /opt/gnupg22
- Install all of gnupg into the buildroot instead of just bin/*

* Tue Jul 09 2019 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.2.17-1
- Update to gnupg-2.2.17

* Mon Feb 18 2019 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.2.13-1
- Update to gnupg-2.2.13

* Thu Jul 12 2018 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.2.9-1
- Update to gnupg-2.2.9

* Tue Jun 12 2018 Konstantin Ryabitsev <konstantin@linuxfoundation.org> - 2.2.8-2
- Very dirty first try
